//wp.data.select( 'core/blocks' ).getBlockTypes() OR wp.blocks.getBlockTypes(), core/quote
;(function($) {
	class BlockEditorAssets {
		constructor () {
			//this.forTest();
			this.isFrontRomEnable = false;
			
			this.appendDefaultContent()
				.appendDefaultButton()
				.toggleClass();
		}

		appendDefaultContent () {
			var self = this;
			
			if(!$('#frontrom-editor').length) {
				var content = $('#frontrom-panel').html();
				
				$('#editor').find('.editor-block-list__layout, .editor-post-text-editor')
					.first()
					.after(content);

				$('#editor').on('click', '#frontrom-go-to-edit-page-link', function() {
					var documentTitle = wp.data.select('core/editor').getEditedPostAttribute('title');

					if (!documentTitle) {
						wp.data.dispatch('core/editor').editPost({
							title: 'FrontRom #' + $('#post_ID').val()
						});
					}

					wp.data.dispatch('core/editor').savePost();
					self.redirectWhenSave();
				})
			}

			return this;
		}

		appendDefaultButton () {
			var self = this;
			
			if(!$('#frontrom-switch-mode-button').length) {
				var editWithButton = $('#frontrom-button-switch-mode').html();
				$('#editor .edit-post-header-toolbar').append(editWithButton);

				$('#editor').on('click', '#frontrom-switch-mode-button', function() {
					if(self.isFrontRomEnable) {

						var wpEditor = wp.data.dispatch('core/editor');
			            wpEditor.editPost({
			                isFrontRomEnable: false
			            });
			            wpEditor.savePost();
			            self.isFrontRomEnable = false;
			            self.toggleClass();

					} else {
						self.isFrontRomEnable = true;
						self.toggleClass();
						$('#frontrom-go-to-edit-page-link').trigger('click');
					}
					
				})
			}

			return this;
		}

		toggleClass () {
			if(!this.isFrontRomEnable) {
				$('#frontrom-editor')
					.addClass('frontrom-display-none');

				$('.frontrom-switch-mode-off')
					.removeClass('frontrom-display-none');

				$('.frontrom-switch-mode-on')
					.addClass('frontrom-display-none');

				$('.editor-block-list__layout')
					.removeClass('frontrom-display-none');
			}

			if(this.isFrontRomEnable) {
				$('#frontrom-editor')
					.removeClass('frontrom-display-none');

				$('.frontrom-switch-mode-on')
					.removeClass('frontrom-display-none');

				$('.frontrom-switch-mode-off')
					.addClass('frontrom-display-none');

				$('.editor-block-list__layout')
					.addClass('frontrom-display-none');
			}
		}


		redirectWhenSave () {
			var self = this;

			setTimeout(function () {
				if (wp.data.select('core/editor').isSavingPost()) {
					self.redirectWhenSave();
				} else {
					location.href = FontRomBE.editLink;
				}
			}, 300);
		}

		forTest () {

			wp.blocks.registerBlockStyle( 'core/quote', {
			    name: 'fancy-quote',
			    label: 'Fancy Quote'
			} );

			wp.domReady( function() {
			   wp.blocks.unregisterBlockStyle( 'core/quote', 'fancy-quote' );
			} );
		}
	}

	$(document).ready(function() {

		setTimeout(function () {
        	new BlockEditorAssets();
      	}, 1);
		
	});
	
})(jQuery)