<?php
/**
 * Plugin Name: FrontRom
 * Plugin URI: https://github.com/helloworldwhoami/forntRom
 * Description: Do everythings like Gutenberg, from frontend.
 * Version: 0.1
 * Author: frontrom
 * Text Domain: frontrom
 *
 * @package frontrom
 */

/**
 * Copyright (c) 2013 James J. Meyer (email: raj.ornob@gmail.com). All rights reserved.
 *
 * Released under the GPL license
 * http://www.opensource.org/licenses/gpl-license.php
 *
 * This is an add-on for WordPress
 * http://wordpress.org/
 *
 * **********************************************************************
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
 * **********************************************************************
 */

final class FrontRom {
	
	public function __construct() {
		$this->init();
		$this->instance();
	}

	private function init() {
		$this->define_constants();
        $this->include_functions();
		$this->register_autoload();
	}

    private function include_functions() {
        include( dirname( __FILE__ ) . '/helpers/functions.php' );
    }

	private function register_autoload() {
		include( dirname( __FILE__ ) . '/vendor/autoload.php' );
	}


    /**
     * Define woogool Constants
     *
     * @return type
     */
    private function define_constants() {
        $this->define( 'FRONTROM_PATH', dirname( __FILE__ ) );
        $this->define( 'FRONTROM_INCLUDES_PATH', dirname( __FILE__ ) . '/includes' );
        $this->define( 'FRONTROM_VIEWS_PATH', dirname( __FILE__ ) . '/views' );
        $this->define( 'FRONTROM_ASSET', plugin_dir_url( __FILE__ ) . 'assets' );
        $this->define( 'FRONTROM_ASSET_PATH', dirname( __FILE__ ) . '/assets' );
        $this->define( 'FRONTROM_TEMPLATE', dirname( __FILE__ ) . '/templates' );
        $this->define( 'FRONTROM_REQUEST_AMOUNT', 2 );
        $this->define( 'FRONTROM_DEBUG', false );
    }

    /**
     * Define constant if not already set
     *
     * @param  string $name
     * @param  string|bool $value
     * @return type
     */
    private function define( $name, $value ) {
        if ( ! defined( $name ) ) {
            define( $name, $value );
        }
    }

    private function instance() {
    	\FrontRom\Includes\Scripts::instance();
    	\FrontRom\Includes\Actions::instance();
    	\FrontRom\Includes\Filters::instance();
    }

}


new FrontRom();









