<?php
namespace FrontRom\Includes;

class Actions {

    private static $_instance;

    public static function instance() {
        if ( !self::$_instance ) {
            self::$_instance = new self();
        }

        return self::$_instance;
    }

    public function __construct() {
        add_action( 'admin_action_frontrom', [ $this, 'frontrom' ] );
        add_action( 'admin_footer', [ $this, 'print_admin_js_template' ] );
    }

    public function frontrom() {
        if( ! isset( $_GET['post'] ) ) {
            return false;
        }
        
        $post_id = empty( absint( $_GET['post'] ) ) ? false : absint( $_GET['post'] );
        $post    = get_post( $post_id );

        if ( empty( $post ) ) {
            return;
        }

        $random_string = frontrom_generate_random_string();

        update_user_meta( get_current_user_id(), 'frontrom_secret_key', $random_string );

        $secret = md5( $random_string );

        $url = add_query_arg( 
            [
                'frontrom'         => 'active',
                'secret'           => $secret,
                'p'                => $post_id,
                'frontrom_post_id' => $post_id
            ],
            home_url() 
        );

        $url = wp_nonce_url( $url );
        
        include( FRONTROM_TEMPLATE . '/edit.php' );
        die;
    }

    public function print_admin_js_template() {
        require_once FRONTROM_TEMPLATE . '/admin-js-template.php';
    }
}